%{
#include "tabsep00.c"
#include "pilasep00.c"

Simbolo * t;
Pila pilaActual=NULL;
%}

%union{
	Simbolo * ptrSimbolo;
	int numero;
	Pila pila;
}
%token DEF FOR PRINT POP
%token <numero> NUM
%token <pila> '{'
%token <ptrSimbolo> ID


%start prog
%%
prog	:	/* Epsilon */
		|	prog sent 
		|	prog error {}	
		;
sent	:	NUM	{
				insertaPilaNUM(&pilaActual, $1);
			}
		|	PRINT {
				insertaPilaPRINT(&pilaActual);
			}
		|	POP {
				insertaPilaPOP(&pilaActual);
			}		
		|	ID	{
				insertaPilaID(&pilaActual, $1);
			}	
		|	DEF ID 	{
				insertaPilaDEF(&pilaActual, $2);
			}
		|	'+'	{
				insertaPilaMas(&pilaActual);
			}	
		|	'*'	{
				insertaPilaPor(&pilaActual);
			}	
		|	'{' {
				$1=pilaActual;
				numeroPilaActual++;
				pilaActual=NULL;
			} listaSent '}' FOR {
				Pila pilaSent=pilaActual;
				pilaActual=$1;
				numeroPilaActual--;
				insertaPilaPila(&pilaActual, pilaSent);
			}
		;		
listaSent	:	/* Epsilon */
			|	listaSent sent
			;
%%
#include "exsep00l.c"

void main(){
	yyin=stdin;
	yyparseerr=stderr;
	t=crear();
	yyparse();
}